﻿Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
        'Add few rows and columns
        For i As Integer = 0 To 4
            C1FlexGrid1.Rows.Add(New C1.Silverlight.FlexGrid.Row())
            C1FlexGrid1.Columns.Add(New C1.Silverlight.FlexGrid.Column() With {.Header = i.ToString()})
        Next

        'Hide 2nd column
        C1FlexGrid1.Columns(2).Visible = False

        'Populate the grid
        For r As Integer = 0 To 4
            For c As Integer = 0 To 4
                C1FlexGrid1(r, c) = String.Format("({0}, {1})", r, c)
            Next
        Next
    End Sub

    'Declare an array to store rows        
    Dim rows As String()

    Private Sub C1FlexGrid_PreviewKeyDown(sender As System.Object, e As System.Windows.Input.KeyEventArgs)

        'Detect CTRL+C
        If e.Key = Key.C AndAlso (Keyboard.Modifiers And ModifierKeys.Control) = ModifierKeys.Control Then
            'If CTRL+C is pressed, we'll hanlde it ourselves
            e.Handled = True
            Dim cr As C1.Silverlight.FlexGrid.CellRange
            'Get selected cellrange
            cr = Me.C1FlexGrid1.Selection

            'Create a StringBuilder object
            Dim sb = New System.Text.StringBuilder()

            'Add celldata to stringbuilder
            'with "\t" appended after every entry
            'and skip column that are not visible
            For i As Integer = cr.TopRow To cr.BottomRow
                For j As Integer = cr.LeftColumn To cr.RightColumn
                    If Me.C1FlexGrid1.Columns(j).Visible Then
                        sb.Append(Me.C1FlexGrid1(i, j).ToString())
                        sb.Append(vbTab)
                    End If
                Next

                'Remove "\t" fom the last position of row
                'and add a new line instead
                sb.Remove(sb.Length - 1, 1)
                sb.Append(Environment.NewLine)
            Next
            'Place the entire string to Clipboard
            Clipboard.SetText(sb.ToString())

            'Detect CTRL + V
        ElseIf e.Key = Key.V AndAlso (Keyboard.Modifiers And ModifierKeys.Control) = ModifierKeys.Control Then
            'If CTRL+V is pressed, we'll hanlde it ourselves
            e.Handled = True

            'Get data from Clipboard
            Dim StrPaste As String = Clipboard.GetText()
            If StrPaste IsNot Nothing Then
                'Populate array "string[] rows" with data
                rows = StrPaste.Split(New String() {Environment.NewLine}, StringSplitOptions.RemoveEmptyEntries)
            End If

            Dim cr As C1.Silverlight.FlexGrid.CellRange
            'Get selected cellrange
            cr = Me.C1FlexGrid1.Selection
            Dim count As Integer = 0

            For i As Integer = cr.TopRow To cr.BottomRow
                'Create an array to store data of each row
                Dim arr As String()
                arr = rows(count).Split(New String() {vbTab}, StringSplitOptions.None)
                Dim z As Integer = 0
                For j As Integer = cr.LeftColumn To cr.RightColumn
                    If Me.C1FlexGrid1.Columns(j).Visible Then
                        'Parse array "arr" and store data in grid's cell 
                        'while skipping invisible columns
                        Me.C1FlexGrid1(i, j) = arr(z)
                        'verify if its only one row (in arr[])
                        If arr.Count() > 1 Then
                            z += 1
                        End If
                    End If
                Next
                If rows.Count() - 1 > count Then
                    count += 1
                End If
            Next
        End If
    End Sub
End Class